// Gobal vars


#ifndef __GLOBAL_VARS
#define __GLOBAL_VARS

//Consensus estimator variables
#define NUM_DATA_SETS 5 	//Number of variables for which consensus needs to be found (Ix, Iy, Ixx, Ixy, Iyy)
#define NUMBERS_PER_SET 2	//Number of datums that need to be transmitted for each variable (x_i, w_i)
#define DATATYPE_BYTELENGTH 4	//Number of bytes in each data type (float = 4 bytes long)
#define DATA_ARRAY_LENGTH (NUM_DATA_SETS*NUMBERS_PER_SET)	//Total number of data in packet
#define ADDITIONAL_NUMS 8	//Additional number of data to be appended to data frame

#define notRTS SELECTOR3	//Define former SELECTOR3 pin for the notRTS pin.


extern unsigned char T1_INT_FLAG;

extern volatile float x_i[NUM_DATA_SETS];	//x, current_estimate/decision variables
extern volatile float u_i[NUM_DATA_SETS];	//u, Controller inputs
extern volatile float w_i[NUM_DATA_SETS];	//w, internal estimator state
extern volatile float x_sum[NUM_DATA_SETS];	//running sums
extern volatile float w_sum[NUM_DATA_SETS];



extern float MAX_WHEEL_V_TICKS; //Max velocity; the larger this is, the less time you have
								 //to do other calculations.  Limit is probably around 750

extern float deadband;  //deadband value for low motor velocity
extern float COMMR;  //Max communication radius

extern float SAFEDIST;	//Distance in mm at which obstacle avoidance will start running.
extern float MINDIST;	//Distance in mm at which obstacle avoidance will dominate the robot's motion.

extern float u_x_ideal;
extern float u_y_ideal;

extern float x_motion_integral;
extern float y_motion_integral;

//***Macros***
#define SQUARE(x) ((x) * (x))




#endif
